--[[
Brian T.Wilcox
twingears@gmail.com
"MATH Fun" program(s) remake 2023
]]
--local utf8 = require("utf8")

--RE-EMBER
--function menu.update(dt, num)
--   displayMenu = num 
--end

--Clean Memory
--function changeMenu(value)
--    tMenu[1] = value
--end

function bySUM(by, bHeight, pad)
    by = by + bHeight + pad
    return by, by
end

function uMenuMathTable()
    local pad2 = 32
    local pad = 16
    local tOffset = 2 --text offset position in pixels
    local bx, by = 32, 32
    local bWidth = VIRTUAL_WIDTH/2 -(pad *2)
    local tx = bx
    local mathEQ = ""   --what about the #'s that have been entered?
    local tableEQ = {}

--    if tMenu = {1} ==
    --Q&A BOXES with TEXT appears to follow the box, so negative space will have to be in the text just like python was...
    bx = pad; by = pad
    local tx = pad; ty = pad
    local bHeight = VIRTUAL_HEIGHT -(pad *3) -pad2 -64 --LARGE BLOCK AS HIGH AS OVERALL MINUS SMALL AND PADS (-64:largefont adjustment)
    
    --MATH EQUATION BOX as string; largest box of both 1/2 screens
    table.insert(tMenu, newButton(function() end, eqString, tx, ty -tOffset, bx, by, bWidth, bHeight, fontLarge, true, false))
    tMenu[#tMenu].tAlinement = "right"  --small change without needing to change data feed per table.insert
--        by = by +pad2 --or
    by = VIRTUAL_HEIGHT -pad -pad2 -64 --easier to catch flaw visually this way
    bHeight = pad2 +64
    tx = bx
    ty = by +pad +2
    -- MATH ANSWER BOX
    table.insert(tMenu, newButton(function() love.keypressed("backspace") end, answerBox, tx, ty -tOffset, bx, by, bWidth, bHeight, fontLarge, true, true))
    tMenu[#tMenu].tAlinement = "right"  --small change without needing to change data feed per table.insert
--        tMenu[#tMenu].text = "Forgive & Heal"
    --2nd 1/2 OF BOXS LIKE A CALCULATOR
    bx = VIRTUAL_WIDTH /2 + pad
    by = pad
    local bWideThird = math.floor((VIRTUAL_WIDTH/2 -(pad *4)) /3)
    bWidth = bWideThird
    bHeight = (VIRTUAL_HEIGHT -(pad *5)) /4
    tx = bx
    ty = by
    tOffset = math.floor(bWidth/3)
                                    --      fn()      text xy           box xy...
    table.insert(tMenu, newButton(function() love.touchpressed("7") end, "7", tx, ty +tOffset, bx, by, bWidth, bHeight, fontLarge, true, true))
    bx = bx + bWidth + pad
    tx = tx + bWidth + pad
    table.insert(tMenu, newButton(function() love.touchpressed("8") end, "8", tx, ty +tOffset, bx, by, bWidth, bHeight, fontLarge, true, true))
    bx = bx + bWidth + pad
    tx = tx + bWidth + pad
    table.insert(tMenu, newButton(function() love.touchpressed("9") end, "9", tx, ty +tOffset, bx, by, bWidth, bHeight, fontLarge, true, true))
    bx = VIRTUAL_WIDTH /2 + pad
    by = by + bHeight + pad
    tx = bx
    ty = by
    table.insert(tMenu, newButton(function() love.touchpressed("4") end, "4", tx, ty +tOffset, bx, by, bWidth, bHeight, fontLarge, true, true))
    bx = bx + bWidth + pad
    tx = tx + bWidth + pad
--        ty = ty + bWidth + pad
    table.insert(tMenu, newButton(function() love.touchpressed("5") end, "5", tx, ty +tOffset, bx, by, bWidth, bHeight, fontLarge, true, true))
    bx = bx + bWidth + pad
    tx = tx + bWidth + pad
--        ty = ty + bWidth + pad
    table.insert(tMenu, newButton(function() love.touchpressed("6") end, "6", tx, ty +tOffset, bx, by, bWidth, bHeight, fontLarge, true, true))
    bx = VIRTUAL_WIDTH /2 + pad
    by = by + bHeight + pad
    tx = bx
    ty = by
--        ty = ty + bHeight + pad
    table.insert(tMenu, newButton(function() love.touchpressed("1") end, "1", tx, ty +tOffset, bx, by, bWidth, bHeight, fontLarge, true, true))
    bx = bx + bWidth + pad
--        local zeroTextX = tx --POSITION OF 2 IS THE SAME AS THE 0...
    tx = tx + bWidth + pad
    table.insert(tMenu, newButton(function() love.touchpressed("2") end, "2", tx, ty +tOffset, bx, by, bWidth, bHeight, fontLarge, true, true))
    bx = bx + bWidth + pad
    tx = tx + bWidth + pad
    table.insert(tMenu, newButton(function() love.touchpressed("3") end, "3", tx, ty +tOffset, bx, by, bWidth, bHeight, fontLarge, true, true))
--      GOING TO NEED A "Done" BUTTON that can mouse over Red/Green to see if user is correct at a glance
--        --by = by + bHeight
--        bx = VIRTUAL_WIDTH /2 + pad
--        by = by + pad + bHeight
--        bWidth = VIRTUAL_WIDTH/2 -(pad*2)    --full width of 1/2 window
----        tx = zeroTextX
--        ty = by
    bx = VIRTUAL_WIDTH /2 + pad
    by = by + bHeight + pad
    tx = bx
    ty = by
--        table.insert(tMenu, newButton(function() keyOrClick("0") end, "0", zeroTextX, ty +tOffset, bx, by, bWidth, bHeight, fontLarge, true, true))
    table.insert(tMenu, newButton(function() answerCheck() end, "Done", tx, ty +tOffset, bx, by, bWidth, bHeight, fontLarge, true, true))
    bx = bx + bWidth + pad
    tx = tx + bWidth + pad
    table.insert(tMenu, newButton(function() love.keypressed("0") end, "0", tx, ty +tOffset, bx, by, bWidth, bHeight, fontLarge, true, true))
    bx = bx + bWidth + pad
    tx = tx + bWidth + pad
    table.insert(tMenu, newButton(function() love.keypressed("backspace") end, "Del", tx, ty +tOffset, bx, by, bWidth, bHeight, fontLarge, true, true))
--    end
--    delDone = false
    return true
end

--DRAW TIME
function dMenuMath()
----    local tOffset = 2 NOT NEEDED ANYMORE AS OBJECT(S) ARE STORED TEXT PIXEL #'s IN PERFECT POSITION...
--    love.graphics.clear()

    --DRAW OUT THE MATH PROGRAM FRONT END
    for i, v in ipairs(tMenu) do
        
        tMenu.last = tMenu.now
        --MOUSE OVER
        local mx, my = love.mouse.getPosition()
--        local colour = {0.59, 0.39, 0.78, 1}
        local colour = v.bColour
        local mouseOver = mx > v.bx and mx < (v.bx +v.bWidth) and my > v.by and my < (v.by +v.bHeight)
        
        if mouseOver and v.bColChangable then   --mouse over box and allowed to change colour
            colour = {0, 1, 0, .8}              --ALARM COLOUR NOT WITHIN BOXS/BUTTONS
        end
        -- THE v's AS .now or now = false - GETS ADDED INTO tMenu TABLE HERE
        v.now = love.mouse.isDown(1) -- 1 IS THE LEFT MOUSE BUTTON IS PRIMARY #1
        if v.now and mouseOver then
            v.fn()
        end
        
        love.graphics.setColor(unpack(colour)) -- v.Colour needs updating
--        colour = tMenu[1].bColour
        love.graphics.rectangle("fill", v.bx, v.by, v.bWidth, v.bHeight)        --1st DRAW Rectangle
--        love.graphics.setColor(tMenu[1].tColour)
        colour = v.tColour
        love.graphics.setColor(colour)
        -- by-2 HELPS PULL THE TEXT UP BY 2 PIXELS
        --NEED TO FILTER OUT THE MATH EQUATION OR ALL THE BUTTONS NEED TO STORE THE SETTING
        love.graphics.printf(v.text, v.fontSize, v.tx, v.ty, v.bWidth, v.tAlinement)
    end
--    delDone = false
end
