--[[
Brian T.Wilcox
twingears@gmail.com
"MATH Fun" program(s) remake 2023
    ]]

-- push is a library that will allow us to draw our game at a virtual
-- resolution, instead of however large our window is; used to provide
-- a more retro aesthetic
--
-- https://github.com/Ulydev/push
push = require 'lib.push'
-- https://github.com/vrld/hump/blob/master/class.lua
--Class = require 'lib.class'
--https://github.com/rxi/classic
Classic = require 'lib.classic'
--require 'src.TileClass'
--Game = require "src.states.Game"
--font32 = require 'src.fonts.Educated.ttf'
-- a few global constants, centralized
require 'src.constants'
require 'src.menu'
require 'src.Math'
--require 'lload'                         --love load function file
-- AABB collision detection
--require 'src/collision.lua'

---- a class used to generate our brick layouts (levels)
--require 'src/LevelMaker'

---- a basic StateMachine class which will allow us to transition to and from
---- game states smoothly and avoid monolithic code in one file
--require 'src/StateMachine'

---- utility functions, mainly for splitting our sprite sheets
--require 'src.Util'
